diff --git a/stdlib.ispc b/stdlib.ispc
index 43e6ebd96..d4eec9ca3 100644
--- a/stdlib.ispc
+++ b/stdlib.ispc
@@ -2721,15 +2733,15 @@ __declspec(safe) static inline uniform float acos(uniform float v) {
 __declspec(safe) static inline void sincos(float x_full, varying float *uniform sin_result,
                                            varying float *uniform cos_result) {
     if (__have_native_trigonometry) {
-        __sincos_varying_float(x_full, sin_result, cos_result);
+        __sincos_varying_float(x_full, (uniform int8 * uniform) sin_result, (uniform int8 * uniform) cos_result);
         return;
     }
     if (__math_lib == __math_lib_svml) {
-        __svml_sincosf(x_full, sin_result, cos_result);
+        __svml_sincosf(x_full, (uniform int8 * uniform) sin_result, (uniform int8 * uniform) cos_result);
     } else if (__math_lib == __math_lib_system) {
         foreach_active(i) {
             uniform float s, c;
-            __stdlib_sincosf(extract(x_full, i), &s, &c);
+            __stdlib_sincosf(extract(x_full, i), (uniform int8 * uniform) & s, (uniform int8 * uniform) & c);
             *sin_result = insert(*sin_result, i, s);
             *cos_result = insert(*cos_result, i, c);
         }
@@ -2790,11 +2802,11 @@ __declspec(safe) static inline void sincos(float x_full, varying float *uniform
 __declspec(safe) static inline void sincos(uniform float x_full, uniform float *uniform sin_result,
                                            uniform float *uniform cos_result) {
     if (__have_native_trigonometry) {
-        __sincos_uniform_float(x_full, sin_result, cos_result);
+        __sincos_uniform_float(x_full, (uniform int8 * uniform) sin_result, (uniform int8 * uniform) cos_result);
         return;
     }
     if (__math_lib == __math_lib_system || __math_lib == __math_lib_svml) {
-        __stdlib_sincosf(x_full, sin_result, cos_result);
+        __stdlib_sincosf(x_full, (uniform int8 * uniform) sin_result, (uniform int8 * uniform) cos_result);
     } else if (__math_lib == __math_lib_ispc || __math_lib == __math_lib_ispc_fast) {
         const uniform float pi_over_two_vec = 1.57079637050628662109375;
         const uniform float two_over_pi_vec = 0.636619746685028076171875;
@@ -3674,7 +3686,7 @@ __declspec(safe) static inline uniform float16 acos(uniform float16 x_full) {
 __declspec(safe) static inline void sincos(float16 x_full, varying float16 *uniform sin_result,
                                            varying float16 *uniform cos_result) {
     if (__have_native_trigonometry) {
-        __sincos_varying_half(x_full, sin_result, cos_result);
+        __sincos_varying_half(x_full, (uniform int8 * uniform) sin_result, (uniform int8 * uniform) cos_result);
     } else {
         *sin_result = (float16)sin((float)x_full);
         *cos_result = (float16)cos((float)x_full);
@@ -3685,7 +3697,7 @@ __declspec(safe) static inline void sincos(float16 x_full, varying float16 *unif
 __declspec(safe) static inline void sincos(uniform float16 x_full, uniform float16 *uniform sin_result,
                                            uniform float16 *uniform cos_result) {
     if (__have_native_trigonometry) {
-        __sincos_uniform_half(x_full, sin_result, cos_result);
+        __sincos_uniform_half(x_full, (uniform int8 * uniform) sin_result, (uniform int8 * uniform) cos_result);
     } else {
         *sin_result = (uniform float16)sin((uniform float)x_full);
         *cos_result = (uniform float16)cos((uniform float)x_full);
@@ -3932,15 +3944,15 @@ __declspec(safe) static inline uniform double acos(const uniform double v) {
 __declspec(safe) static inline void sincos(double x, varying double *uniform sin_result,
                                            varying double *uniform cos_result) {
     if (__have_native_trigonometry) {
-        __sincos_varying_double(x, sin_result, cos_result);
+        __sincos_varying_double(x, (uniform int8 * uniform) sin_result, (uniform int8 * uniform) cos_result);
         return;
     }
     if (__math_lib == __math_lib_svml) {
-        __svml_sincosd(x, sin_result, cos_result);
+        __svml_sincosd(x, (uniform int8 * uniform) sin_result, (uniform int8 * uniform) cos_result);
     } else {
         foreach_active(i) {
             uniform double sr, cr;
-            __stdlib_sincos(extract(x, i), &sr, &cr);
+            __stdlib_sincos(extract(x, i), (uniform int8 * uniform) & sr, (uniform int8 * uniform) & cr);
             *sin_result = insert(*sin_result, i, sr);
             *cos_result = insert(*cos_result, i, cr);
         }
@@ -3950,9 +3962,9 @@ __declspec(safe) static inline void sincos(double x, varying double *uniform sin
 __declspec(safe) static inline void sincos(uniform double x, uniform double *uniform sin_result,
                                            uniform double *uniform cos_result) {
     if (__have_native_trigonometry) {
-        __sincos_uniform_double(x, sin_result, cos_result);
+        __sincos_uniform_double(x, (uniform int8 * uniform) sin_result, (uniform int8 * uniform) cos_result);
     } else
-        __stdlib_sincos(x, sin_result, cos_result);
+        __stdlib_sincos(x, (uniform int8 * uniform) sin_result, (uniform int8 * uniform) cos_result);
 }
 
 __declspec(safe) static inline double tan(double x) {
@@ -5159,7 +5171,7 @@ static inline uniform bool rdrand(float *uniform ptr) {
         return false;
     else {
         uniform int32 irand;
-        uniform bool success = __rdrand_i32(&irand);
+        uniform bool success = __rdrand_i32((uniform int8 * uniform) & irand);
         if (success) {
             irand &= (1ul << 23) - 1;
             *ptr = floatbits(0x3F800000 | irand) - 1.0f;
@@ -5175,7 +5187,7 @@ static inline bool rdrand(varying float *uniform ptr) {
         bool success = false;
         foreach_active(index) {
             uniform int32 irand;
-            if (__rdrand_i32(&irand)) {
+            if (__rdrand_i32((uniform int8 * uniform) & irand)) {
                 // FIXME: it probably would be preferable, here and in the
                 // following rdrand() function, to do the int->float stuff
                 // in vector form.  However, we need to be careful to not
@@ -5200,7 +5212,7 @@ static inline bool rdrand(float *ptr) {
         bool success = false;
         foreach_active(index) {
             uniform int32 irand;
-            if (__rdrand_i32(&irand)) {
+            if (__rdrand_i32((uniform int8 * uniform) & irand)) {
                 irand &= (1ul << 23) - 1;
                 *ptrs[index] = floatbits(0x3F800000 | irand) - 1.0f;
                 success = true;
@@ -5214,7 +5226,7 @@ static inline uniform bool rdrand(int16 *uniform ptr) {
     if (__have_native_rand == false)
         return false;
     else
-        return __rdrand_i16(ptr);
+        return __rdrand_i16((int8 * uniform) ptr);
 }
 
 static inline bool rdrand(varying int16 *uniform ptr) {
@@ -5224,7 +5236,7 @@ static inline bool rdrand(varying int16 *uniform ptr) {
         bool success = false;
         foreach_active(index) {
             uniform int16 irand;
-            if (__rdrand_i16(&irand)) {
+            if (__rdrand_i16((uniform int8 * uniform) & irand)) {
                 *ptr = irand;
                 success = true;
             }
@@ -5243,7 +5255,7 @@ static inline bool rdrand(int16 *ptr) {
 
         foreach_active(index) {
             uniform int16 irand;
-            if (__rdrand_i16(&irand)) {
+            if (__rdrand_i16((uniform int8 * uniform) & irand)) {
                 *ptrs[index] = irand;
                 success = true;
             }
@@ -5256,7 +5268,7 @@ static inline uniform bool rdrand(int32 *uniform ptr) {
     if (__have_native_rand == false)
         return false;
     else
-        return __rdrand_i32(ptr);
+        return __rdrand_i32((int8 * uniform) ptr);
 }
 
 static inline bool rdrand(varying int32 *uniform ptr) {
@@ -5266,7 +5278,7 @@ static inline bool rdrand(varying int32 *uniform ptr) {
         bool success = false;
         foreach_active(index) {
             uniform int32 irand;
-            if (__rdrand_i32(&irand)) {
+            if (__rdrand_i32((uniform int8 * uniform) & irand)) {
                 *ptr = irand;
                 success = true;
             }
@@ -5285,7 +5297,7 @@ static inline bool rdrand(int32 *ptr) {
 
         foreach_active(index) {
             uniform int32 irand;
-            if (__rdrand_i32(&irand)) {
+            if (__rdrand_i32((uniform int8 * uniform) & irand)) {
                 *ptrs[index] = irand;
                 success = true;
             }
@@ -5298,7 +5310,7 @@ static inline uniform bool rdrand(int64 *uniform ptr) {
     if (__have_native_rand == false)
         return false;
     else
-        return __rdrand_i64(ptr);
+        return __rdrand_i64((int8 * uniform) ptr);
 }
 
 static inline bool rdrand(varying int64 *uniform ptr) {
@@ -5308,7 +5320,7 @@ static inline bool rdrand(varying int64 *uniform ptr) {
         bool success = false;
         foreach_active(index) {
             uniform int64 irand;
-            if (__rdrand_i64(&irand)) {
+            if (__rdrand_i64((uniform int8 * uniform) & irand)) {
                 *ptr = irand;
                 success = true;
             }
@@ -5327,7 +5339,7 @@ static inline bool rdrand(int64 *ptr) {
 
         foreach_active(index) {
             uniform int64 irand;
-            if (__rdrand_i64(&irand)) {
+            if (__rdrand_i64((uniform int8 * uniform) & irand)) {
                 *ptrs[index] = irand;
                 success = true;
             }
